--[[----------------------------------------------------------------------]]--
--[[--LostTreasures_WaypointsHandler.lua								--]]--
--[[--See README.html for more info										--]]--
--[[----------------------------------------------------------------------]]--
function LostTreasures:DoWaypoints(opts)
-- LostTreasures:DoWaypoints({  [removeAll = true, removePoint = 0,]  [addAll = true, addPoint = 0,]  blockPoint = false, clearBlocked = false, setArrow = true})
	opts = opts or {}
	if ( _LT.sv.ENABLED and GetCurrentMapContinent() == 6 ) then
		if ( opts.removeAll == nil ) then opts.removeAll = true end
		if ( opts.addAll == nil ) then opts.addAll = true end
		if ( opts.blockPoint == nil ) then opts.blockPoint = false end
		if ( opts.clearBlocked == nil ) then opts.clearBlocked = false end
		if ( opts.setArrow == nil ) then opts.setArrow = true end
		if ( opts.removePoint == nil ) then opts.removePoint = 0 end
		opts.removePoint = tonumber(opts.removePoint)
		if ( opts.addPoint == nil ) then opts.addPoint = 0 end
		opts.addPoint = tonumber(opts.addPoint)
		
		if ( opts.removeAll or opts.removePoint > 0 ) then
			self:RemoveWaypoints(opts.removePoint, opts.blockPoint)
		end
		
		if ( opts.clearBlocked ) then
			_LT.sv.BLOCKED_WAYPOINTS = {}
		end
		
		if ( opts.addAll or opts.addPoint > 0 ) then
			self:AddWaypoints(opts.addPoint)
		end
		
		if ( opts.setArrow and _LT.sv.USE_ARROW ) then
			TomTom:SetClosestWaypoint()
		end
		
	else
		self:RemoveWaypoints(0, false)
	end
end

function LostTreasures:RemoveWaypoints(point, blockPoint)
	point = point or 0
	for zone, quests in pairs(_LT.waypoints) do
		for quest, waypoint in pairs(quests) do
			if ( point == 0 or (point > 0 and point == quest) ) then
				for i = 1, #waypoint.coords, 4 do
					local f, x, y, title = waypoint.coords[i + 2], waypoint.coords[i] / 100, waypoint.coords[(i + 1)] / 100, self:GetTitle(waypoint)
					local key = TomTom:GetKey({zone, f, x, y, title = title})
					if ( TomTom.waypoints[zone] and TomTom.waypoints[zone][key] ) then
						TomTom:RemoveWaypoint(TomTom.waypoints[zone][key], blockPoint)
					end
				end
			end
		end
	end
end

function LostTreasures:AddWaypoints(point)
	point = point or 0
	for zone, quests in pairs(_LT.waypoints) do
		for quest, waypoint in pairs(quests) do
if ( quest ~= 31399 or (quest == 31399 and not _LT.sv.BLOCK_MINING_PICK) ) then -- pick patch
			if ( point == 0 or (point > 0 and point == quest) ) then
				if ( IsQuestFlaggedCompleted(quest) == nil or _LT.sv.SHOW_ALL_WAYPOINTS ) then
					if ( _LT.sv.SHOW_WAYPOINT_TYPE == 1 or (_LT.sv.SHOW_WAYPOINT_TYPE == 2 and not waypoint.achievement) or (_LT.sv.SHOW_WAYPOINT_TYPE == 3 and waypoint.achievement) ) then
						local config = {
							crazy = _LT.sv.USE_ARROW, 
							world = _LT.sv.USE_WORLDMAP, 
							minimap = _LT.sv.USE_MINIMAP, 
							persistent = false, 
							callbacks = TomTom:DefaultCallbacks({
								CLEARDISTANCE = _LT.sv.CLEARDISTANCE, 
							}), 
						}
						for i = 1, #waypoint.coords, 4 do
							local f, x, y, title = waypoint.coords[i + 2], waypoint.coords[i] / 100, waypoint.coords[(i + 1)] / 100, self:GetTitle(waypoint)
							local key = TomTom:GetKey({zone, f, x, y, title = title})
							
							if ( _LT.sv.BLOCKED_WAYPOINTS[zone] and _LT.sv.BLOCKED_WAYPOINTS[zone][key] ) then
								printd("Blocked Point: "..quest)
							else
								config.title = title
								TomTom:AddMFWaypoint(zone, f, x, y, config)
							end
						end
					end
				end
			end
end -- end pick patch
		end
	end
end

function LostTreasures:GetTitle(waypoint)
	if ( waypoint.cave ) then
		return waypoint.title.."\nEnter the cave at ("..waypoint.coords[1]..", "..waypoint.coords[2]..").\n"..waypoint.note
	else
		return waypoint.title.."\n"..waypoint.note
	end
end

--[[----------------------------------------------------------------------]]--
--[[--Modified method(s) from TomTom for custom behavior. All code from	--]]--
--[[--here to the bottom of this document are property of TomTom.		--]]--
--[[--All modified code is commented for observation purposes.			--]]--
--[[--TomTom:RemoveWaypoint(uid)										--]]--
--[[--TomTom:GetClosestWaypoint()										--]]--
--[[----------------------------------------------------------------------]]--
function TomTom:RemoveWaypoint(uid, blockPoint)
	local data = uid
	TomTom:ClearWaypoint(uid)

	local key = TomTom:GetKey(data)
	local mapId = data[1]
	local sv = TomTom.waypointprofile[mapId]

	if sv and sv[key] then
		sv[key] = nil
	end

-- ]--> Added Block
	if ( blockPoint == nil ) then
		blockPoint = true
	end
	if ( _LT.sv.ENABLED and _LT.sv.USE_SESSIONS and blockPoint ) then
		if ( TomTom.waypoints[mapId] and TomTom.waypoints[mapId][key] ) then
			_LT.sv.BLOCKED_WAYPOINTS[mapId] = _LT.sv.BLOCKED_WAYPOINTS[mapId] or {}
			_LT.sv.BLOCKED_WAYPOINTS[mapId][key] = uid
		end
	end
-- <--[ End Block

	-- Remove this entry from the waypoints table
	if TomTom.waypoints[mapId] then
		TomTom.waypoints[mapId][key] = nil
	end
end

function TomTom:GetClosestWaypoint()
	local m, f, x, y = TomTom:GetCurrentPlayerPosition()
	local c = LibMapData:GetContinentFromMap(m)

	local closest_waypoint = nil
	local closest_dist = nil
	local found = false -- <--[ local var to check if treasure found

	if not TomTom.profile.arrow.closestusecontinent then
		-- Simple search within this zone
		if TomTom.waypoints[m] then
-- ]--> Added Block > Gets the closest treasure waypoint (in this zone) before other waypoints if settings are correct.
			if ( _LT.sv.ENABLED and _LT.sv.USE_ARROW and _LT.sv.TREASURE_FIRST ) then
				for quest, waypoint in pairs(_LT.waypoints[m]) do
					for i = 1, #waypoint.coords, 4 do
						local f, x, y, title = waypoint.coords[i + 2], waypoint.coords[i] / 100, waypoint.coords[(i + 1)] / 100, LostTreasures:GetTitle(waypoint)
						local key = TomTom:GetKey({m, f, x, y, title = title})
						if ( TomTom.waypoints[m] and TomTom.waypoints[m][key] ) then
							local dist, x, y = TomTom:GetDistanceToWaypoint(TomTom.waypoints[m][key])
							if ( (dist and closest_dist == nil) or (dist and dist < closest_dist) ) then
								closest_dist = dist
								closest_waypoint = TomTom.waypoints[m][key]
								found = true
							end
						end
					end
				end
			end
-- <--[ End
			if ( closest_waypoint == nil ) then -- <--[ We didn't get a waypoint above, lets use the default TomTom code
				for key, waypoint in pairs(TomTom.waypoints[m]) do
					local dist, x, y = TomTom:GetDistanceToWaypoint(waypoint)
					if (dist and closest_dist == nil) or (dist and dist < closest_dist) then
						closest_dist = dist
						closest_waypoint = waypoint
					end
				end
			end -- <--[ End
		end
	else
-- ]--> Added Block > Gets the closest treasure waypoint (in Pandaria) before other waypoints if settings are correct.
		if ( _LT.sv.ENABLED and _LT.sv.USE_ARROW and _LT.sv.TREASURE_FIRST ) then
			for zone, quests in pairs(_LT.waypoints) do
				for quest, waypoint in pairs(quests) do
					if ( c == LibMapData:GetContinentFromMap(zone) ) then
						for i = 1, #waypoint.coords, 4 do
							local f, x, y, title = waypoint.coords[i + 2], waypoint.coords[i] / 100, waypoint.coords[(i + 1)] / 100, LostTreasures:GetTitle(waypoint)
							local key = TomTom:GetKey({zone, f, x, y, title = title})
							if ( TomTom.waypoints[zone] and TomTom.waypoints[zone][key] ) then
								local dist, x, y = TomTom:GetDistanceToWaypoint(TomTom.waypoints[zone][key])
								if ( (dist and closest_dist == nil) or (dist and dist < closest_dist) ) then
									closest_dist = dist
									closest_waypoint = TomTom.waypoints[zone][key]
									found = true
								end
							end
						end
					end
				end
			end
		end
-- <--[ End
		if ( closest_waypoint == nil ) then -- <--[ We didn't get a waypoint above, lets use the default TomTom code
			-- Search all waypoints on this continent
			for map, waypoints in pairs(TomTom.waypoints) do
				if c == LibMapData:GetContinentFromMap(map) then
					for key, waypoint in pairs(waypoints) do
						local dist, x, y = TomTom:GetDistanceToWaypoint(waypoint)
						if (dist and closest_dist == nil) or (dist and dist < closest_dist) then
							closest_dist = dist
							closest_waypoint = waypoint
						end
					end
				end
			end
		end -- <--[ End
	end

	if closest_dist then
-- ]--> Added Block > Allows the printing of detailed information if we are allowing it and we found a treasure waypoint.
		if ( found and _LT.sv.SHOW_DETAILED_INFO ) then
			print(closest_waypoint.title)
		end
-- <--[ End
		return closest_waypoint
	end
end